#! /usr/bin/env python
#-*- coding: UTF8 -*-
# PSP Tools

"""
Mapping of the PSP buttons on a PC, usefull for beta-testing
 z = cross
 a = square
 s = circle
 w = triangle
 e = r-trigger
 q = l-trigger
 v = start
 c = select
 up,down,left,right = arrow keys
"""

changelog = """
Alpha:
	Successfuly ported the core to the psp, no user input, no release
Alpha 0.1:
	Added user input
	Fixed version.txt bug
	Added more tools: pixel fix and button test
	renamed the project
	public release
"""

import os, pspos, psp2d
from time import time
pspos.setclock(222)
pspos.setbus(111)
WHITE_COLOR = psp2d.Color(255,255,255)
CLEAR_COLOR = psp2d.Color(0,0,0)
RED_COLOR   = psp2d.Color(255, 0, 0)
GREEN_COLOR = psp2d.Color(0, 255, 0)
BLUE_COLOR  = psp2d.Color(0,50,255)
YELLOW_COLOR  = psp2d.Color(255,255,0)
scr = psp2d.Screen()
fnt = psp2d.Font('font.png')
img = psp2d.Image(480, 272)
log = open("log.txt", "w")
log = open("log.txt", "a")

def scan():
	if os.path.isdir("ms0:/MP_ROOT") == False:
		os.mkdir("ms0:/MP_ROOT")
		log.write("ms0:/MP_ROOT missing...fixed\n")
	if os.path.isdir("ms0:/MP_ROOT/100MNV01") == False:
		os.mkdir("ms0:/MP_ROOT/100MNV01")
		log.write("ms0:/MP_ROOT/100MNV01 missing...fixed\n")
	if os.path.isdir("ms0:/MP_ROOT/101ANV01") == False:
		os.mkdir("ms0:/MP_ROOT/101ANV01")
		log.write("ms0:/MP_ROOT/101ANV01 missing...fixed\n")
	if os.path.isdir("ms0:/PSP") == False:
		os.mkdir("ms0:/PSP")
		log.write("ms0:/PSP missing...fixed\n")
	if os.path.isdir("ms0:/PSP/GAME") == False:
		os.mkdir("ms0:/PSP/GAME")
		log.write("ms0:/PSP/GAME missing...fixed\n")
	if os.path.isdir("ms0:/PSP/GAME150") == False:
		os.mkdir("ms0:/PSP/GAME150")
		log.write("ms0:/PSP/GAME150 missing...fixed\n")
	if os.path.isdir("ms0:/PSP/SAVEDATA") == False:
		os.mkdir("ms0:/PSP/SAVEDATA")
		log.write("ms0:/PSP/SAVEDATA missing...fixed\n")
	if os.path.isdir("ms0:/PSP/PHOTO") == False:
		os.mkdir("ms0:/PSP/PHOTO")
		log.write("ms0:/PSP/PHOTO missing...fixed\n")
	if os.path.isdir("ms0:/PSP/VIDEO") == False:
		os.mkdir("ms0:/PSP/VIDEO")
		log.write("ms0:/PSP/VIDEO missing...fixed\n")
	if os.path.isdir("ms0:/PSP/THEME") == False:
		os.mkdir("ms0:/PSP/THEME")
		log.write("ms0:/PSP/THEME missing...fixed\n")
	if os.path.isdir("ms0:/PSP/COMMON") == False:
		os.mkdir("ms0:/PSP/COMMON")
		log.write("ms0:/PSP/COMMON missing...fixed\n")
	if os.path.isdir("ms0:/PSP/SYSTEM") == False:
		os.mkdir("ms0:/PSP/SYSTEM")
		log.write("ms0:/PSP/SYSTEM missing...fixed\n")
	if os.path.isdir("ms0:/PSP/RSSCH") == False:
		os.mkdir("ms0:/PSP/RSSCH")
		log.write("ms0:/PSP/RSSCH missing...fixed\n")
	if os.path.isdir("ms0:/PSP/RSSCH/IMPORT") == False:
		os.mkdir("ms0:/PSP/RSSCH/IMPORT")
		log.write("ms0:/PSP/RSSCH/IMPORT missing...fixed\n")
	if os.path.isdir("ms0:/PSP/MUSIC") == False:
		os.mkdir("ms0:/PSP/MUSIC")
		log.write("ms0:/PSP/MUSIC missing...fixed\n")
	if os.path.isdir("ms0:/VIDEO") == False:
		os.mkdir("ms0:/VIDEO")
		log.write("ms0:/VIDEO missing...fixed\n")
	if os.path.isdir("ms0:/MUSIC") == False:
		os.mkdir("ms0:/MUSIC")
		log.write("ms0:/MUSIC missing...fixed\n")
	if os.path.isdir("ms0:/PICTURE") == False:
		os.mkdir("ms0:/PICTURE")
		log.write("ms0:/PICTURE missing...fixed\n")
	if os.path.isdir("ms0:/ISO") == False:
		os.mkdir("ms0:/ISO")
		log.write("ms0:/ISO missing...fixed\n")
	if os.path.isdir("ms0:/ISO/VIDEO") == False:
		os.mkdir("ms0:/ISO/VIDEO")
		log.write("ms0:/ISO/VIDEO missing...fixed\n")
	if os.path.isdir("ms0:/SEPLUGINS") == False:
		os.mkdir("ms0:/SEPLUGINS")
		log.write("ms0:/SEPLUGINS missing...fixed\n")
	try: open("ms0:/SEPLUGINS/game.txt", "r").close()
	except:
		open("ms0:/SEPLUGINS/game.txt", "w").close()
		log.write("ms0:/SEPLUGINS/game.txt missing...fixed\n")
	try: open("ms0:/SEPLUGINS/pops.txt", "r").close()
	except:
		open("ms0:/SEPLUGINS/pops.txt", "w").close()
		log.write("ms0:/SEPLUGINS/pops.txt missing...fixed\n")
	try: open("ms0:/SEPLUGINS/vsh.txt", "r").close()
	except:
		open("ms0:/SEPLUGINS/vsh.txt", "w").close()
		log.write("ms0:/SEPLUGINS/vsh.txt missing...fixed\n")
	try: open("ms0:/SEPLUGINS/game150.txt", "r").close()
	except:
		open("ms0:/SEPLUGINS/game150.txt", "w").close()
		log.write("ms0:/SEPLUGINS/game150.txt missing...fixed\n")
	try: open("ms0:/SEPLUGINS/version.txt", "r").close()
	except:
		open("ms0:/SEPLUGINS/version.txt", "w").write("""release:9.90:
build:6666,0,3,1,0:builder@vsh-build6
system:54865@release_610,0x09090010:
vsh:p6501@release_610,v55286@release_610,20121221:
target:1:WorldWide
""")
		log.write("ms0:/SEPLUGINS/version.txt missing...fixed\n")
	try: open("ms0:/MEMSTICK.IND", "r").close()
	except:
		open("ms0:/MEMSTICK.IND", "w").close()
		log.write("ms0:/MEMSTICK.IND missing...fixed\n")
	done("Directories fixed")

def pixel_fix():
	x12 = True
	while x12 == True:
		pad = psp2d.Controller()
		img.clear(WHITE_COLOR)
		scr.blit(img)
		scr.swap()
		img.clear(RED_COLOR)
		scr.blit(img)
		scr.swap()
		img.clear(GREEN_COLOR)
		scr.blit(img)
		scr.swap()
		img.clear(BLUE_COLOR)
		scr.blit(img)
		scr.swap()
		img.clear(YELLOW_COLOR)
		scr.blit(img)
		scr.swap()
		if pad.triangle:
			x12 = False
			done("Pixel Fix cancelled, quit?")
			

def button_test():
	x0 = True
	while x0 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press X""")
		scr.blit(img)
		scr.swap()
		if pad.cross:
			x0 = False
	x1 = True
	while x1 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Circle""")
		scr.blit(img)
		scr.swap()
		if pad.circle:
			x1 = False
	x2 = True
	while x2 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Square""")
		scr.blit(img)
		scr.swap()
		if pad.square:
			x2 = False
	x3 = True
	while x3 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Triangle""")
		scr.blit(img)
		scr.swap()
		if pad.triangle:
			x3 = False
	x4 = True
	while x4 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Right Trigger""")
		scr.blit(img)
		scr.swap()
		if pad.r:
			x4 = False
	x5 = True
	while x5 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Left Trigger""")
		scr.blit(img)
		scr.swap()
		if pad.l:
			x5 = False
	x6 = True
	while x6 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Start""")
		scr.blit(img)
		scr.swap()
		if pad.start:
			x6 = False
	x7 = True
	while x7 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Select""")
		scr.blit(img)
		scr.swap()
		if pad.select:
			x7 = False
	x8 = True
	while x8 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Left""")
		scr.blit(img)
		scr.swap()
		if pad.left:
			x8 = False
	x9 = True
	while x9 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Right""")
		scr.blit(img)
		scr.swap()
		if pad.right:
			x9 = False
	x10 = True
	while x10 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Up""")
		scr.blit(img)
		scr.swap()
		if pad.up:
			x10 = False
	x11 = True
	while x11 == True:
		pad = psp2d.Controller()
		img.clear(CLEAR_COLOR)
		fnt.drawText(img, 0, 60, """Press Down""")
		scr.blit(img)
		scr.swap()
		if pad.down:
			x11 = False
	done("Button test finished, quit?")

def done(custom=input):
	img.clear(psp2d.Color(0, 0, 0))
	fnt.drawText(img, 0, 0, custom)
	fnt.drawText(img, 0, 30, "Start  --> main menu")
	fnt.drawText(img, 0, 60, "Select --> exit")
	scr.blit(img)
	scr.swap()
	x = True
	while x == True:
		pad = psp2d.Controller()
		if pad.start:
			x = False
			main()
		elif pad.select:
			fnt.drawText(img, 0, 90, "Exiting...")
			scr.blit(img)
			scr.swap()
			break

def main():
	img.clear(CLEAR_COLOR)
	fnt.drawText(img, 0, 0,  """Cross    -->   Directory Fix""")
	fnt.drawText(img, 0, 30, """Triangle -->   Button Test""")
	fnt.drawText(img, 0, 60, """Square   -->   Pixel Fix""")
	fnt.drawText(img, 0, 90, """Circle   -->   Exit""")
	scr.blit(img)
	scr.swap()
	x = True
	while x == True:
		pad = psp2d.Controller()
		if pad.cross:
			x = False
			scan()
		elif pad.circle:
			x = False
			done("Exit?")
		elif pad.square:
			x = False
			pixel_fix()
		elif pad.triangle:
			x = False
			button_test()
main()
